DisMaxRequestHandler (Solr 3.6.2 API)
Keywords: org.apache.solr.handler.DisMaxRequestHandler class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.solr.handler
Class DisMaxRequestHandler

    java.lang.Object
      org.apache.solr.handler.RequestHandlerBase
          org.apache.solr.handler.component.SearchHandler
              org.apache.solr.handler.StandardRequestHandler
                  org.apache.solr.handler.DisMaxRequestHandler

All Implemented Interfaces:
  SolrInfoMBean, SolrRequestHandler, PluginInfoInitialized, SolrCoreAware

Direct Known Subclasses:
  DisMaxRequestHandler

Deprecated. use StandardRequestHandler with a "defType=dismax" param

    @Deprecated
    public class DisMaxRequestHandler

extends StandardRequestHandler

A Generic query plugin designed to be given a simple query expression from a user, which it will then query against a variety of pre-configured fields, in a variety of ways, using BooleanQueries, DisjunctionMaxQueries, and PhraseQueries.

All of the following options may be configured for this plugin in the solrconfig as defaults, and may be overriden as request parameters

- q.alt - An alternate query to be used in cases where the main query (q) is not specified (or blank). This query should be expressed in the Standard SolrQueryParser syntax (you can use `q.alt=*:*` to denote that all documents should be returned when no query is specified)
- tie - (Tie breaker) float value to use as tiebreaker in DisjunctionMaxQueries (should be something much less than 1)
- qf - (Query Fields) fields and boosts to use when building DisjunctionMaxQueries from the users query. Format is: "`fieldA^1.0 fieldB^2.2`". This param can be specified multiple times, and the fields are additive.
- mm - (Minimum Match) this supports a wide variety of complex expressions. read `SolrPluginUtils.setMinShouldMatch` and mm expression format for details.
- pf - (Phrase Fields) fields/boosts to make phrase queries out of, to boost the users query for exact matches on the specified fields. Format is: "`fieldA^1.0 fieldB^2.2`". This param can be specified multiple times, and the fields are additive.
- ps - (Phrase Slop) amount of slop on phrase queries built for pf fields.
- qs - (Query Slop) amount of slop on phrase queries explicitly specified in the "q" for qf fields.
- bq - (Boost Query) a raw lucene query that will be included in the users query to influence the score. If this is a BooleanQuery with a default boost (1.0f), then the individual clauses will be added directly to the main query. Otherwise, the query will be included as is. This param can be specified multiple times, and the boosts are are additive. NOTE: the behaviour listed above is only in effect if a single `bq` paramter is specified. Hence you can disable it by specifying an additional, blank, `bq` parameter.
- bf - (Boost Functions) functions (with optional boosts) that will be included in the users query to influence the score. Format is: "`funcA(arg1,arg2)^1.2 funcB(arg3,arg4)^2.2`". NOTE: Whitespace is not allowed in the function arguments. This param can be specified multiple times, and the functions are additive.
- fq - (Filter Query) a raw lucene query that can be used to restrict the super set of products we are interested in - more efficient then using bq, but doesn't influence score. This param can be specified multiple times, and the filters are additive.

The following options are only available as request params...

- q - (Query) the raw unparsed, unescaped, query from the user.
- sort - (Order By) list of fields and direction to sort on.

     :TODO: document facet param support

Nested Class Summary

Nested classes/interfaces inherited from interface org.apache.solr.core.SolrInfoMBean
`SolrInfoMBean.Category`

Field Summary

Fields inherited from class org.apache.solr.handler.component.SearchHandler
`components, log`

Fields inherited from class org.apache.solr.handler.RequestHandlerBase
`appends, defaults, httpCaching, initArgs, invariants`

Constructor Summary
`DisMaxRequestHandler()` Deprecated.

Method Summary
`String` | `getDescription()` Deprecated. Simple one or two line description
`URL[]` | `getDocs()` Deprecated. Documentation URL list.
`String` | `getSource()` Deprecated. CVS Source, SVN Source, etc
`String` | `getSourceId()` Deprecated. CVS Id, SVN Id, etc
`String` | `getVersion()` Deprecated. Simple common usage version, e.g.
`void` | `init(NamedList args)` Deprecated. Initializes the `SolrRequestHandler` by creating three `SolrParams` named.

Methods inherited from class org.apache.solr.handler.component.SearchHandler
`getComponents, getDefaultComponents, handleRequestBody, inform, init`

Methods inherited from class org.apache.solr.handler.RequestHandlerBase
`getCategory, getInitArgs, getName, getStatistics, handleRequest`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DisMaxRequestHandler

    public DisMaxRequestHandler()

  Deprecated.

Method Detail

### init

    public void init(NamedList args)

  Deprecated.
  Description copied from class: `RequestHandlerBase`
  Initializes the `SolrRequestHandler` by creating three `SolrParams` named.

  Name | Description
  --- | ---
  defaults | Contains all of the named arguments contained within the list element named "defaults".
  appends | Contains all of the named arguments contained within the list element named "appends".
  invariants | Contains all of the named arguments contained within the list element named "invariants".

  Example:

       <lst name="defaults">
       <str name="echoParams">explicit</str>
       <str name="qf">text^0.5 features^1.0 name^1.2 sku^1.5 id^10.0</str>
       <str name="mm">2<-1 5<-2 6<90%</str>
       <str name="bq">incubationdate_dt:[* TO NOW/DAY-1MONTH]^2.2</str>
       </lst>
       <lst name="appends">
       <str name="fq">inStock:true</str>
       </lst>

       <lst name="invariants">
       <str name="facet.field">cat</str>
       <str name="facet.field">manu_exact</str>
       <str name="facet.query">price:[* TO 500]</str>
       <str name="facet.query">price:[500 TO *]</str>
       </lst>

  Specified by:
    `init` in interface `SolrRequestHandler`
  Overrides:
    `init` in class `RequestHandlerBase`
  Parameters:
    `args` - The `NamedList` to initialize from
  See Also:
    `RequestHandlerBase.handleRequest(org.apache.solr.request.SolrQueryRequest, org.apache.solr.response.SolrQueryResponse)`, `RequestHandlerBase.handleRequestBody(org.apache.solr.request.SolrQueryRequest, org.apache.solr.response.SolrQueryResponse)`, `SolrPluginUtils.setDefaults(org.apache.solr.request.SolrQueryRequest, org.apache.solr.common.params.SolrParams, org.apache.solr.common.params.SolrParams, org.apache.solr.common.params.SolrParams)`, `See also the example solrconfig.xml located in the Solr codebase (example/solr/conf).`

### getDescription

    public String getDescription()

  Deprecated.
  Description copied from interface: `SolrInfoMBean`
  Simple one or two line description

  Specified by:
    `getDescription` in interface `SolrInfoMBean`
  Overrides:
    `getDescription` in class `StandardRequestHandler`

### getVersion

    public String getVersion()

  Deprecated.
  Description copied from interface: `SolrInfoMBean`
  Simple common usage version, e.g. 2.0

  Specified by:
    `getVersion` in interface `SolrInfoMBean`
  Overrides:
    `getVersion` in class `StandardRequestHandler`

### getSourceId

    public String getSourceId()

  Deprecated.
  Description copied from interface: `SolrInfoMBean`
  CVS Id, SVN Id, etc

  Specified by:
    `getSourceId` in interface `SolrInfoMBean`
  Overrides:
    `getSourceId` in class `StandardRequestHandler`

### getSource

    public String getSource()

  Deprecated.
  Description copied from interface: `SolrInfoMBean`
  CVS Source, SVN Source, etc

  Specified by:
    `getSource` in interface `SolrInfoMBean`
  Overrides:
    `getSource` in class `StandardRequestHandler`

### getDocs

    public URL[] getDocs()

  Deprecated.
  Description copied from interface: `SolrInfoMBean`
  Documentation URL list.

  Suggested documentation URLs: Homepage for sponsoring project, FAQ on class usage, Design doc for class, Wiki, bug reporting URL, etc...

  Specified by:
    `getDocs` in interface `SolrInfoMBean`
  Overrides:
    `getDocs` in class `StandardRequestHandler`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD